#!/usr/bin/perl
################################################################################
#
# This Perl program code COPYRIGHT 2005 Paul Galloway. All Rights Reserved.
# Program may not be sold or distributed except by express written permission
# of the author.
#
# The use of any part of this program or any code segments from it for any
# purpose, personal or commercial, is forbidden except by express written 
# permission of Paul Galloway.
#
# You may contact the author at the following email address:
#
# Email: paulg@paulgalloway.com
#
##############################################################################
# d.cgi?file-affnum!extendedcode
# OR
# d.cgi?affnum!extendedcode
#
# (!extendedcode is always optional)
#
unshift (@INC, ".");
require (options);
open(STDERR, ">errors/d.errors");
system "chmod 777 $originals_dir";
system "chmod 777 $clone_root";
system "chmod 777 $log_dir";
system "chmod 777 $temp_dir";
system "chmod 777 $ip_dir";
if (-e "ycookies.pm") { require (ycookies);}


$buffer = $ENV{'QUERY_STRING'};
$buffer =~ tr/\&\;\`\'\\\"\|\*\?\~\<\>\^\(\)\[\]\{\}\$\n\r/                      /;

if ($buffer !~ /\-/)
{
	$file = "index";
	$dnum_ext = $buffer;
}
else { ($file, $dnum_ext) = split ('-', $buffer); }

if ($odd_day_dir ne "") #ycookies has been loaded
{
	$dnum_ext = &determine_affnum($dnum_ext);
}

($dn, $extension) = split('!', $dnum_ext);

&get_dealer_info;

$specified_file = $file;


$disable_file = $clone_root . "/" . $dn . "/yoapdisabled.txt";
if (-e $disable_file) { $file = $log_dir . "/disabled_account_message.txt"; }
else { $file = $originals_dir . "/" . $file . ".txt"; }

open (TEMPLATE, "<$file");
@tlines = <TEMPLATE>;
close (TEMPLATE);

print "Content-type: text/html\n\n";

$temp = join('', @tlines);
$temp =~ s/AFF_NUM/$dnum_ext/g;
$temp =~ s/AFF_NAME/$dealer_name $dealer_lastname/g;
$temp =~ s/AFF_FIRSTNAME/$dealer_name/g;
$temp =~ s/AFF_LASTNAME/$dealer_lastname/g;
$temp =~ s/AFF_EMAIL/$dealer_email/g;
$temp =~ s/AFF_URL/$dealer_url/g;
$temp =~ s/AFF_PHONE/$phone/g;
$temp =~ s/AFF_ADDRESS/$address1/g;
$temp =~ s/AFF_SUITE/$suite/g;
$temp =~ s/AFF_CITY/$city/g;
$temp =~ s/AFF_STATE/$state/g;
$temp =~ s/AFF_ZIP/$zip/g;
$temp =~ s/AFF_COUNTRY/$country/g;
$temp =~ s/AFF_CUSTOM1/$c1/g;
$temp =~ s/AFF_CUSTOM2/$c2/g;
$temp =~ s/AFF_CUSTOM3/$c3/g;
$temp =~ s/AFF_CUSTOM4/$c4/g;
$temp =~ s/AFF_CUSTOM5/$c5/g;
print $temp;


if ($log_hits > 0 && (! -e $disable_file)) #log hit to access log file
{
	$files_to_log =~ s/\s//g;
	$files_to_log = ',' . $files_to_log . ','; 
	#make sure every page name has a comma on both sides -- used in regexp below

	if ($files_to_log eq ',,')
	{ 
		$files_to_log = ",index,"; 
	}

	if 	($files_to_log =~ /\,$specified_file\,/i || $files_to_log eq "\,ALL\,")
	{ 
		&update_logs($dn); 
	}
}

exit;


sub get_dealer_info
{
	$info_file = $nfo_dir . "/" . $dn . ".nfo";
	if (-e $info_file)
	{
		system "chmod 777 $info_file";
		open(DEALERFILE, "<$info_file");
		@lines=<DEALERFILE>;
		close(DEALERFILE);
		system "chmod $security $info_file";
		$dataline=$lines[2];
		if ($dataline =~ /\n$/ ) {chop $dataline;}
		($dealer_name,$dealer_lastname,$dealer_email,$address1,$suite,$city,$state,$zip,$phone,$country,$dn2,$pw,$ld,$ip,$cb1,$cb2,$c1,$c2,$c3,$c4,$c5,$dealer_url,$dealer_ul) = split (/\|/, $dataline);
	}
}


sub update_logs
{
	my $log_line;
	my $log_dir;
	my $ip;
	
	&get_date;
  	#returns $long_date = "$year-$months[$mon]-$mday\@$hour\:$min\:$sec";
  	#returns $month = [1-12]
  	
  	my @date_stuff = split (/\-/,$long_date);
  	my $this_year = $date_stuff[0];
  	my ($this_day, $this_time) = split(/\@/, $date_stuff[2]);
  	my $month = $date_stuff[1];
  	if (length($this_day) < 2) { $this_day = '0' . $this_day;} #want two characters always
  	
  	$log_dir = $access_log_dir;
  	if ($log_dir eq "")
  	{
  		$log_dir = $log_dir . "/access_logs";
  	}
  	
  	if (! -e $log_dir)
	{
  		mkdir ($log_dir, 0777);
  	}
    	$d_log_file = $log_dir . "/" . $this_year . '-' . $month . '-' . $this_day . '.traffic';
    	
    	
    	my $host = $ENV{'REMOTE_HOST'};
    	$host = "- n/a -" if ($host eq "");
    	
    	$ip = $ENV{'REMOTE_ADDR'};
      	$ip = "- n/a -" if ($ip eq "");
      	
      	my $referrer = $ENV{'HTTP_REFERER'};
      	$referrer = "Bookmark/Unknown" if ($referrer eq "");
      	#if ($log_hits > 1)
      	#{
      		$log_line = "$dn\|$extension\|$month\/$this_day\/$this_year $this_time\|$ip\|$host\|$specified_file\|$referrer\n";
      	#}
      	#else
      	#{
      	#	$log_line = "$dn\|$extension\|$month\/$this_day\/$this_year $this_time\n";
      	#}
      	
      	chmod (0666, $d_log_file);
    	open (LOGFILE, ">>$d_log_file");
    	print LOGFILE $log_line;
    	close(LOGFILE);
}


sub get_date
{
	#creates a whole slew of global date variables:
	# examples: 
	# date = "09:23:12 01/12/1999"
	# long_date = "1999-Jan-12@09:23:12"
	# thismonth = "Jan"
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
    	$sec = "0$sec" if ($sec < 10);
    	$min = "0$min" if ($min < 10);
	$hour = "0$hour" if ($hour < 10);
	$mday = "0$mday" if ($mday < 10);
	$month=$mon+1;
	$month = "0$month" if ($month < 10);
	my @months = ("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
	$year += 1900;
  	$yyyymmdd = "$year$month$mday";
	$date = "$hour\:$min\:$sec $month/$mday/$year";
  	chop($date) if ($date =~ /\n$/);
  	$long_date = "$year-$months[$mon]-$mday\@$hour\:$min\:$sec";
  	$thismonth = $months[$mon];
}
