#!/usr/bin/perl
################################################################################
#
# This Perl program code COPYRIGHT 2005 Paul Galloway. All Rights Reserved.
# Program may not be sold or distributed except by express written permission
# of the author.
#
# The use of any part of this program or any code segments from it for any
# purpose, personal or commercial, is forbidden except by express written 
# permission of Paul Galloway.
#
# You may contact the author at the following email address:
#
# Email: paulg@paulgalloway.com
#
##############################################################################

unshift (@INC, ".");
require (options);
open(STDERR, ">errors/dealmod.errors");
system "chmod 777 $originals_dir";
system "chmod 777 $clone_root";
system "chmod 777 $log_dir";
system "chmod 777 $temp_dir";
system "chmod 777 $ip_dir";

$cgi_script = $cgi_url . "/dealmod.cgi";
$seed = srand ( time() ^ ($$ + ($$ << 15)) );

&get_input;
&check_password;

if ($action eq "update")
{
  &start_url;
  &update;
  print "Update Confirmed. The following information was written:<P>";
  &print_record;
  print "</BODY></HTML>";
  exit;
}
elsif ($action eq "delete" &&  $FORM{'confirmed'} eq "YES")
{
  &delete_record;
  &start_url;
  print "Delete confirmed. The following record was deleted, and the affiliate\'s website removed:<P>";
  &print_record;
  print "</BODY></HTML>";
  exit;
}
else 
{
  &start_url;
  print "Sorry, you must confirm your decision to delete this affiliate\'s web site and contact information. <P> Please hit the \"BACK\" button and check the confirmation checkbox at the bottom of the form (only IF you want to DELETE this record!) . . .";
  print "</BODY></HTML>";
  exit;
}



sub get_input
{
  if ($ENV{'REQUEST_METHOD'} eq "GET")
  {
    $buffer=$ENV{'QUERY_STRING'};
  }
  else 
  {
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
  }

  @pairs = split(/&/, $buffer);
  foreach $pair (@pairs) 
  {
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/<!--(.|\n)*-->//g;
    $value =~ s/\|/ /g;
    $FORM{$name} = $value;
  }
  foreach $key (keys %FORM)
  {
  	$FORM{$key} =~ tr/\&\;\`\'\\\"\|\*\?\~\<\>\^\(\)\[\]\{\}\$\n\r/                      /;
  }
  
  $aff_num = $FORM{'aff_num'};
  $aff_num =~ s/ //g;
  $password = $FORM{'password'};
  $password =~ s/ //g;
  $action = $FORM{'action'};
}


sub print_record
{
      print "<PRE>";
      print "First Name:       $FORM{'name'}<BR>";
      print "Last Name:        $FORM{'lastname'}<BR>";
      print "Address:          $FORM{'address1'}<BR>";
      print "Suite:            $FORM{'suite'}<BR>";
      print "City,State,Zip:   $FORM{'city'}\,$FORM{'state'} $FORM{'zip'}<BR>";
      print "Country:          $FORM{'country'}<BR>";
      print "Phone:            $FORM{'phone'}<BR>";
      print "Email:            $FORM{'email'}<BR>";
      print "Home URL:         $FORM{'url'}<P>";
      print "Sponsor:          $FORM{'ul'}<BR>";
      print "Affiliate Number: $FORM{'aff_num'}<BR>";
      print "Affiliate Level:  $FORM{'level'}<BR>";
      print "Password:         $FORM{'pw'}<BR>";
      print "Signup Date:      $FORM{'ld'}<BR>";
      print "IP Address:       $FORM{'ip'}<BR>";
      print "Checkbox1:        $FORM{'cb1'}<BR>";
      print "Checkbox2:        $FORM{'cb2'}<BR>";
      print "Custom1:          $FORM{'c1'}<BR>";
      print "Custom2:          $FORM{'c2'}<BR>";
      print "Custom3:          $FORM{'c3'}<BR>";
      print "Custom4:          $FORM{'c4'}<BR>";
      print "Custom5:          $FORM{'c5'}<BR>";
      print "Custom5:          $FORM{'c5'}<BR>";
      print "</PRE><HR>";
} 


sub check_password
{
  $passfile = $log_dir . "/" . "password.txt";
  if (-e $passfile)
  {
    system "chmod 444 $passfile";
    open(PASSFILE, "<$passfile");
    $master_password = <PASSFILE>;
    close(PASSFILE);
    system "chmod $security $passfile";
    chop $master_password if ($master_password =~ /\n$/);
    $try = crypt ($password, "aa");
    if ($master_password eq $try)
    {
      return;
    }
  }
  &start_url;
  print "Sorry, \"$password\" does not match the recorded master password (admin password) -- please try again. <P>If you have never created a new password, please enter a new password in the \"change password\" section (at the very bottom of the admin page) before you try to use the admin functions . . .";
  print "</BODY></HTML>";
  exit;
}


sub update
{  
   $clone_dir =~ s/AFF_NUM/$aff_num/g;
   $info_file = $nfo_dir . "/" . $aff_num . ".nfo";
   #$pass = $clone_dir . "/" . "password.txt";
   #system "chmod 777 $pass";
   #open (PASS, ">$pass");
   #$encrypted = crypt($FORM{'pw'}, "aa");
   #print PASS "$encrypted";
   #close(PASS);
   #system "chmod $security $pass";
   system "chmod 777 $info_file";
   open(NEWFILE, ">$info_file");
   print NEWFILE "$FORM{'email'}\n";
   print NEWFILE "$FORM{'level'}\n";
   print NEWFILE "$FORM{'name'}\|$FORM{'lastname'}\|$FORM{'email'}\|$FORM{'address1'}\|$FORM{'suite'}\|$FORM{'city'}\|$FORM{'state'}\|$FORM{'zip'}\|$FORM{'phone'}\|$FORM{'country'}\|$FORM{'aff_num'}\-$FORM{'level'}\|$FORM{'pw'}\|$FORM{'ld'}\|$FORM{'ip'}\|$FORM{'cb1'}\|$FORM{'cb2'}\|$FORM{'c1'}\|$FORM{'c2'}\|$FORM{'c3'}\|$FORM{'c4'}\|$FORM{'c5'}\|$FORM{'url'}\|$FORM{'ul'}\n";
   print NEWFILE "$FORM{'ul'}\n";
   close(NEWFILE);
   system "chmod $security $info_file";
   $logfilename = $log_dir . "/" . $file_prefix . "-dealers.txt";
   system "chmod 777 $logfilename";
   open(LOGFILE, ">>$logfilename");
   print LOGFILE "$FORM{'name'}\-UPDATE\-\|$FORM{'lastname'}\|$FORM{'email'}\|$FORM{'address1'}\|$FORM{'suite'}\|$FORM{'city'}\|$FORM{'state'}\|$FORM{'zip'}\|$FORM{'phone'}\|$FORM{'country'}\|$FORM{'aff_num'}\-$FORM{'level'}\|$FORM{'pw'}\|$FORM{'ld'}\|$FORM{'ip'}\|$FORM{'cb1'}\|$FORM{'cb2'}\|$FORM{'c1'}\|$FORM{'c2'}\|$FORM{'c3'}\|$FORM{'c4'}\|$FORM{'c5'}\|$FORM{'url'}\|$FORM{'ul'}\n";
   close(LOGFILE);
   system "chmod $security $logfilename";

   #ONLY DO THIS IF STATIC AFF PAGES ARE SUPPORTED AS EVIDENCED BY EXISTING AFF_NUM DIRECTORY
   ########
   $clone_dir = $clone_root . "/" . $aff_num; 
   unless (-e $clone_dir && $clone_root ne "" && $make_static_capable eq "yes") { return; }
   ########
   
   
	opendir(FILELIST, "$originals_dir");   
	@allfiles = readdir(FILELIST);
	closedir(FILELIST);
	@files = (); #in case we ever run this as Apache Registry code.
	foreach $possible (@allfiles)
	{
		if ($possible =~ /\.htm/ || $possible =~ /\.shtm/) 
		{ 
			$fullpathname = $originals_dir . "/" . $possible;
			push(@files, $fullpathname); 
		}
	}   
	$clone_dir = $clone_root . "/" . $aff_num; 
	if ($aff_num eq "" || $aff_num =~ /^\./) { return; }
	system "chmod 777 $clone_dir/*.htm";
	system "chmod 777 $clone_dir/*.html";
	system "chmod 777 $clone_dir/*.shtml";
	system "rm $clone_dir/*.htm";
	system "rm $clone_dir/*.html"; 
	system "rm $clone_dir/*.shtml"; 
	#print "Updating $clone_dir...<BR>";
	foreach $file(@files)
	{ 
		chop $file if ($file =~ /\n$/);
		@pathfields= split(/\//, $file);
		$filename = pop(@pathfields);
		open(TEMPLATE, "<$file");
		@lines=<TEMPLATE>;
		close(TEMPLATE);
		$newfile = $clone_dir . "/" . $filename;
		system "chmod 777 $newfile";
		print "Updating $newfile . . .<BR>";
		open(NEWFILE, ">$newfile");
		$line = join('', @lines);
		$line =~ s/AFF_NUM/$FORM{'aff_num'}/g;
		$line =~ s/AFF_NAME/$FORM{'name'} $FORM{'lastname'}/g;
		$line =~ s/AFF_FIRSTNAME/$FORM{'name'}/g;
		$line =~ s/AFF_LASTNAME/$FORM{'lastname'}/g;
		$line =~ s/AFF_EMAIL/$FORM{'email'}/g;
		$line =~ s/AFF_URL/$FORM{'url'}/g;
		$line =~ s/AFF_PHONE/$FORM{'phone'}/g;
		$line =~ s/AFF_ADDRESS/$FORM{'address1'}/g;
		$line =~ s/AFF_SUITE/$FORM{'suite'}/g;
		$line =~ s/AFF_CITY/$FORM{'city'}/g;
		$line =~ s/AFF_STATE/$FORM{'state'}/g;
		$line =~ s/AFF_ZIP/$FORM{'zip'}/g;
		$line =~ s/AFF_COUNTRY/$FORM{'country'}/g;
		$line =~ s/AFF_CUSTOM1/$FORM{'c1'}/g;
		$line =~ s/AFF_CUSTOM2/$FORM{'c2'}/g;
		$line =~ s/AFF_CUSTOM3/$FORM{'c3'}/g;
		$line =~ s/AFF_CUSTOM4/$FORM{'c4'}/g;
		$line =~ s/AFF_CUSTOM5/$FORM{'c5'}/g;
		print NEWFILE "$line";
		close(NEWFILE);
	}
	system "chmod $security $clone_dir/*";
	system "chmod 755 $clone_dir/*.html";
	system "chmod 755 $clone_dir/*.htm";
	system "chmod 755 $clone_dir/*.shtml";   
}


sub delete_record 
{  
   $clone_dir = $clone_root . "/" . $aff_num; 
   if (-e $clone_dir)
   {
	system "chmod 777 $clone_dir";
	system "chmod 777 $clone_dir/*";
	system "rm $clone_dir/*";
	system "rmdir $clone_dir";
   }
   
   $info_file = $nfo_dir . "/" . $aff_num . ".nfo";
   system "chmod 777 $info_file";
   system "rm $info_file";

   $logfilename = $log_dir . "/" . $file_prefix . "-dealers.txt";
   system "chmod 777 $logfilename";
   open(LOGFILE, ">>$logfilename");
   print LOGFILE "$FORM{'name'}\-DELETED\-\|$FORM{'lastname'}\n$FORM{'email'}\|$FORM{'address1'}\|$FORM{'suite'}\|$FORM{'city'}\|$FORM{'state'}\|$FORM{'zip'}\|$FORM{'phone'}\|$FORM{'country'}\|$FORM{'aff_num'}\-$FORM{'level'}\|$FORM{'pw'}\|$FORM{'ld'}\|$FORM{'ip'}\|$FORM{'cb1'}\|$FORM{'cb2'}\|$FORM{'c1'}\|$FORM{'c2'}\|$FORM{'c3'}\|$FORM{'c4'}\|$FORM{'c5'}\|$FORM{'url'}\n";
   close(LOGFILE);
   system "chmod $security $logfilename";

   if ($dealer_dbfile ne "" && -e $dealer_dbfile_dir)
   {	   
   	&checklock;
	dbmopen(%DEALERS, $dealer_dbfile, 0666); #this file uses URLs as keys, with affiliate
	%AFFILIATES = %DEALERS;
	foreach $key (keys %AFFILIATES)
	{
		if ($AFFILIATES{$key} eq $aff_num) { delete $AFFILIATES{$key}; }
	}
	%DEALERS = %AFFILIATES;
	dbmclose(%DEALERS);
	&unlock;
   }
}


sub checklock
{
  ##
  ## Check to make sure dbm file is not being written by another
  ## process. This is done by way of a lock file in $log_dir/lock.
  ## 
  ## Summary: First, clear out any lock files older than $maxlocktime
  ## seconds. Then, write lock file, wait 1 second and see if any 
  ## other lock files are present. If so, see which one has the newest
  ## time stamp. If present time stamp is oldest, but another one
  ## exists with same time stamp, then use alphabetic selection.
  ## 
  ## If someone else is older, wait one second and try again, clearing
  ## "expired" files before each time-stamp comparison.
  ## 
  ## Keep looping back until this lock file is oldest or one of the 
  ## oldest and first alphabetically
  ## 
  
  my $lockfilerand;
  
  $valid_chars="abcdefghjkmnpqrstwxyzABCDEFGHJKLMNPQRSTWXYZ23456789";
  $lockfilename = "";
  for ($i=0; $i<16; $i++)
  {
    $randomnumber = int(rand 53);
    $letter = substr($valid_chars,$randomnumber,1);
    $lockfilerand = $lockfilerand . $letter;
  }
  $time = (time);
  $lockfilename = $lock_dir . "/" . $lockfilerand . ".$time";

  if (! -e $lock_dir) { system "mkdir $lock_dir"; system "chmod 777 $lock_dir"; }
  open (LOCKFILE, ">$lockfilename");
  close(LOCKFILE);
#  sleep(2); #sleep at least 1 second, no more than 2.
  select(undef, undef, undef, 1.0); # Sleep one second (doesn't work on all systems, but it does on this one)
  
  #file written xxxxxxxxxxxxxxxx.ttttttttt where "ttttttttt" is epoch time
  # Now it's time to play "wait your turn"
  
  while ($atbat ne $lockfilename)
  { 
    $identicals = 0;     #
    %randomhash = ();    #   start
    @times = ();         #   fresh
    @randomparts=();     #
    opendir(LOCKDIR, "$lock_dir");
    @lockfiles = readdir(LOCKDIR);
    closedir(LOCKDIR);
    foreach $lockfile (@lockfiles)
    {
      if (length($lockfile) > 16) #only evaluate files that should be there
      { 
        chomp($lockfile);
        ($randompart, $timepart) = split(/\./, $lockfile);
        $elapsed_time = (time) - $timepart;
        if ($elapsed_time > $maxlocktime) 
        { 
          $fullname = $lock_dir . "/" . $lockfile; 
          unlink $fullname; 
        }
        else
        {
          $randomhash{$randompart} = $timepart;
          push(@times, $timepart);
        }
      }
    }
    @times = sort {$a <=> $b} @times;
    $oldest_time = $times[0];
    foreach $key (keys %randomhash)
    { 
      if ($randomhash{$key} == $oldest_time)
      {
        push(@randomparts, $key); # get list of randomparts coinciding with oldest time (1 or more)
      }
    }
    @sorted_randoms = sort (@randomparts);
    $atbat = $lock_dir . "/" . $sorted_randoms[0] . ".$randomhash{$sorted_randoms[0]}"; 
    # This file has the absolute oldest time, OR it is "tied" for the 
    # oldest time, and is first in alphabetical order
  }
  return;
}


sub unlock
{
	system "rm $lockfilename";
	return;
}
