#!/usr/bin/perl
################################################################################
#
# This Perl program code COPYRIGHT 2005 Paul Galloway. All Rights Reserved.
# Program may not be sold or distributed except by express written permission
# of the author.
#
# The use of any part of this program or any code segments from it for any
# purpose, personal or commercial, is forbidden except by express written 
# permission of Paul Galloway.
#
# You may contact the author at the following email address:
#
# Email: paulg@paulgalloway.com
#
##############################################################################

unshift (@INC, ".");
if ($ENV{'REQUEST_METHOD'})
{
	print "Content-type: text/html\n\n";
	print "<CENTER><B><FONT SIZE=\"+3\">Access Forbidden</FONT></B></CENTER>";
	exit;
}

require (options);
open(STDERR, ">errors/telnetupdate.errors");
system "chmod 777 $originals_dir";
system "chmod 777 $clone_root";
system "chmod 777 $log_dir";
system "chmod 777 $temp_dir";
system "chmod 777 $ip_dir";
$aff_num = "ALL";
&get_dealers;
$num_of_dealers = @dealers;
if ($num_of_dealers > 0)
{ 
	opendir(FILELIST, "$originals_dir");   
	@allfiles = readdir(FILELIST);
	closedir(FILELIST);

	@files = (); #in case we ever run this as Apache Registry code.
	foreach $possible (@allfiles)
	{
		if ($possible =~ /\.htm/ || $possible =~ /\.shtm/) 
		{ 
			$fullpathname = $originals_dir . "/" . $possible;
			push(@files, $fullpathname); 
		}
	}

	foreach $aff_num (@dealers)
	{
		&update;
		$count++;
	}
	print "\n\nDone! $count affiliate accounts updated!\n\n";
}
else
{
	print "No affiliate sites could be found in $clone_root . . .";
}
exit;


sub update 
{  
   system "chmod 777 $clone_root";
   &get_dealer_info;
   $clone_dir = $clone_root . "/" . $aff_num;
   system "chmod 777 $clone_dir";
   system "rm $clone_dir/*.htm";
   system "rm $clone_dir/*.html";
   foreach $file(@files)
   { 
     chop $file if ($file =~ /\n$/);
     @pathfields= split(/\//, $file);
     $filename = pop(@pathfields);
     open(TEMPLATE, "<$file");
     @lines=<TEMPLATE>;
     close(TEMPLATE);
     $newfile = $clone_dir . "/" . $filename;
     open(NEWFILE, ">$newfile");
     foreach $line(@lines)
     {
	$line =~ s/AFF_NUM/$aff_num/g;
	$line =~ s/AFF_NAME/$dealer_name $dealer_lastname/g;
	$line =~ s/AFF_LASTNAME/$dealer_lastname/g;
	$line =~ s/AFF_FIRSTNAME/$dealer_name/g;
	$line =~ s/AFF_EMAIL/$dealer_email/g;
	$line =~ s/AFF_URL/$dealer_url/g;
	$line =~ s/AFF_PHONE/$phone/g;
	$line =~ s/AFF_ADDRESS/$address1/g;
	$line =~ s/AFF_SUITE/$suite/g;
	$line =~ s/AFF_CITY/$city/g;
	$line =~ s/AFF_STATE/$state/g;
	$line =~ s/AFF_ZIP/$zip/g;
	$line =~ s/AFF_COUNTRY/$country/g;
	$line =~ s/AFF_CUSTOM1/$c1/g;
	$line =~ s/AFF_CUSTOM2/$c2/g;
	$line =~ s/AFF_CUSTOM3/$c3/g;
	$line =~ s/AFF_CUSTOM4/$c4/g;
	$line =~ s/AFF_CUSTOM5/$c5/g;
       print NEWFILE "$line";
     }
     close(NEWFILE);
   }
   $ifile = $clone_dir . "/index.html";
   $ifile2 = $clone_dir . "/index.htm";
   if ( (! -e $ifile) && (! -e $ifile2) )
   {
      open (PRIVACY, ">$ifile");
      close (PRIVACY)
   }
   system "chmod $security $clone_dir/*";
   system "chmod 755 $clone_dir/*.html";
   system "chmod 755 $clone_dir/*.htm";
   system "chmod 777 $clone_dir";
   system "chmod 777 $clone_root";

   print "Update complete for affiliate number $aff_num\n";
}


sub get_dealers
{
	opendir(DEALERDIR, "$nfo_dir");
	@dealer_info_files = grep(/\.nfo/, readdir(DEALERDIR));
	closedir(DEALERDIR);
	foreach $dealer_info_file (@dealer_info_files)
	{
		my $dnum = $dealer_info_file;
		$dnum =~ s/\.nfo//;
		push (@dealers, $dnum);
	}
}


sub get_dealer_info
{
  $info_file = $nfo_dir . "/" . $aff_num . ".nfo";
  system "chmod 777 $info_file";
  open(DEALERFILE, "<$info_file");
  @lines=<DEALERFILE>;
  close(DEALERFILE);
  system "chmod $security $info_file";
  $dataline=$lines[2];
  if ($dataline =~ /\n$/ ) {chop $dataline;}
  ($dealer_name, $dealer_lastname,$dealer_email,$address1,$suite,$city,$state,$zip,$phone,$country,$dn,$pw,$ld,$ip,$cb1,$cb2,$c1,$c2,$c3,$c4,$c5,$dealer_url,$dealer_ul) = split (/\|/, $dataline);
  $dealer_level = $lines[1];
  if ($dealer_level =~ /\n$/ ) {chop $dealer_level;}
}
