################################################################################
#
# This Perl program code COPYRIGHT 2005 Paul Galloway. All Rights Reserved.
# Program may not be sold or distributed except by express written permission
# of the author.
#
# The use of any part of this program or any code segments from it for any
# purpose, personal or commercial, is forbidden except by express written 
# permission of Paul Galloway.
#
# You may contact the author at the following email address:
#
# Email: paulg@paulgalloway.com
#
##############################################################################

$dbase_out = 1;

sub dbase_out
{
	my ($call_func) = @_;
	my @data = ();
	my @data2 = ();
	my @data3 = ();
	my @data4 = ();
	my @validlist = ();
	my @labels = ();
	my @no_dup=();
	my @order = ();
	my @null_array = ();
	my $filename;
	my @num_array = ();
	my $file_ext;
	my $label_name;
	my $filepass;
	my $exist_flag=0;		

	if ($report eq "list")
	{
		@labels = (Affiliate_Number,FirstName,LastName,Email);
		@num_array = (1,2,3,4);
		$file_ext = ".jj1";
	}	
	if ($report eq "listall")
	{
		@labels = (FirstName,LastName,Address,Suite,City,State,Zip,Country,
      			   Phone,Email,Home_URL,Number,Level,Password,Signup_Date,IP_Address,
      			   Checkbox1,Checkbox2,Custom1,Custom2,Custom3,Custom4,Custom5,Sponsor);
		@num_array = (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24);
		$file_ext = ".jj2";
      	}
      	if ($report eq "maillist")	
      	{
      		@labels = (FirstName,LastName,Address,Suite,City,State,Zip,Country);
  		@num_array = (1,2,3,4,5,6,7,8);
  		$file_ext = ".jj3";
	}
	
	if ($report =~ /comm/)	
      	{		
		@labels = (Dealer_Num,FirstName,LastName,Address,Suite,City,State,Zip,Country);
           	@num_array = (1,2,3,4,5,6,7,8,9);
           	@no_dup = @num_array;
           	if ($FORM{'format'} eq "detailed")
     		{
     		     	push @labels,(Date,Product,Quantity,Commission);
  			push @num_array,(10,11,12,13);
  			$file_ext = ".jj4";
  		}
  		else
  		{
  			push @labels, (Month,Transactions,Commission);
  			push @num_array,(10,11,12);
  			$file_ext = ".jj5";
  		}
  	
	}

	if ($report eq "orders")	
      	{	if ($FORM{'format'} eq "abbreviated")
     		{	    
			@labels = (Date,Name,Order_Total);
           		@num_array = (1,2,3);
           		$file_ext = ".jj6";
           	}
           	else
     		{
     		     	#@labels = (Date,Referred_By,Name,Address,Suite,City,State,Zip,Country,Phone,Email);
     		     	#push @labels,(Credit_Card,Card_Number,Expiration,Name_on_Card,IP_Address);
     		     	#push @labels,(Custom1,Custom2,Custom3,Custom4,Custom5);
     		     	#@num_array = (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21);
     		     	
     		     	@labels = (Date,Referred_By,Name,Email,IP_Address);
     		     	@num_array = (1,2,3,4,5);
     		     	@no_dup = @num_array;
     		     	push @labels,(Item,Quantity,Price);
      			#push @num_array,(22,23,24);
      			push @num_array,(6,7,8);
  			$file_ext = ".jj7";
  		}
  	
	}

	if ($FORM{'B_SUB'} =~ /OUTPUT/)
	{
		&start_url;
  		if ($report eq "listmod")
  		{
 	   		print "<P>Sorry, but you cannot use the \"Output To File\" button for this function.";
    			print "Please hit the \"BACK\" key to return to the options screen.";
    			print "</BODY></HTML>";
  		}
  		else
  		{
  			&draw_dbase_table(\@labels,$file_ext,$call_func,\@num_array);
  		}
  		
  	}
  	elsif ($FORM{'B_SUB'} =~ /DOWNLOAD/)
  	{
    		@order = &order_data(@labels);	
    		@labels = &re_order_array(\@labels,\@order,\@null_array);				
  		
  		$filename = &open_db_file;
  		&print_db_labels(@labels);
  		if ($report =~ /list/)  #Handle Affiliate Reports
  		{
  			if ($FORM{'keyword'} ne "") {$aff_num = "ALL";}
  			if ($aff_num eq "ALL")
  			{
    				&get_dealers;
    				foreach $aff_num(@dealers)
    				{	 
	      				@data = &get_list_info;
      					if (@data)
      					{
      						@data = &re_order_array(\@data,\@order,\@null_array);
      						&print_db_data(@data);
      					}
    				}
  			}
  			else 
  			{
	 	 		@data = &get_list_info;
 		 		@data = &re_order_array(\@data,\@order);
 	 			&print_db_data(@data);
  			}
  		}
  		elsif ($report =~ /comm/)   #Handle Commission Reports
		{

			for ($i=0; $i<12; $i++)
  			{
    				if ($months[$i] eq $FORM{'month'}) 
    				{	 
	      				$query_month = $i;
      					last;
    				}
  			}
  			if ($aff_num eq "ALL")
  			{
		    		&get_dealers;
    				foreach $aff_num(@dealers)
    				{ 
			      		if (&get_info_file)
	    				{
			      			@data = &get_dealer_info;
			      			($name,$lastname,$email,$address1,$suite,$city,$state,$zip,$phone,$country,$dn,$pw,$ld,$ip,$cb1,$cb2,$c1,$c2,$c3,$c4,$c5,$dealer_url,$ul) = @data;
			      			@data=($aff_num,$name,$lastname,$address1,$suite,$city,$state,$zip,$country);
        		      			@data2 = &get_db_month;
						$exist_flag ||= $transactions_exist;			
			      			if (($FORM{'format'} eq "detailed")&&($transactions_exist))
			      			{
			      				$monthly_comm = pop @data2;
			      				$xx=0;
			      				for (@data2)
			      				{
			      					@data4 = split(/;\|;/,$_);
			      					@data3 = @data;
      								push @data3,@data4;
      								if ($xx)
      								{
      									@data3 = &re_order_array(\@data3,\@order,\@no_dup);
      								}
      								else
      								{
      									@data3 = &re_order_array(\@data3,\@order,\@null_array);
      								}
			      					&print_db_data(@data3);
			      					$xx ||= 1;
			      				}
			      			}
			      			else
			      			{	
  							@data3 = @data;
      							push @data3,@data2;
      							@data3 = &re_order_array(\@data3,\@order,\@null_array);
      							&print_db_data(@data3) if($transactions_exist);
      						} 
      					}	 
    				}	
  			}
  			else  #$aff_num != "ALL";
  			{ 
    				if (&get_info_file)
	    			{
	      				@data = &get_dealer_info;
	      				($name,$lastname,$email,$address1,$suite,$city,$state,$zip,$phone,$country,$dn,$pw,$ld,$ip,$cb1,$cb2,$c1,$c2,$c3,$c4,$c5,$dealer_url,$ul) = @data;
			      		@data=($aff_num,$name,$lastname,$address1,$suite,$city,$state,$zip,$country);
      					@data2 = &get_db_month;
      					$exist_flag ||= $transactions_exist;
					if (($FORM{'format'} eq "detailed")&&($transactions_exist))
			      		{
			      			$monthly_comm = pop @data2;
			      			$xx = 0;
			      			for (@data2)
			      			{
			      				@data4 = split(/;\|;/,$_);
			      				@data3 = @data;
      							push @data3,@data4;
      							if ($xx)
      							{
      								@data3 = &re_order_array(\@data3,\@order,\@no_dup);
      							}
      							else
      							{
      								@data3 = &re_order_array(\@data3,\@order,\@null_array);
      							}
			      				&print_db_data(@data3);
			      				$xx ||= 1;
			      			}
			      		}
			      		else
			      		{	
  						@data3 = @data;
      						push @data3,@data2;
      						@data3 = &re_order_array(\@data3,\@order,\@null_array);
      						&print_db_data(@data3) if($transactions_exist);
      					}
    				}
    				
  			}
  		}
  		elsif ($report eq "orders") #Handle order reports
  		{
  			@validlist = &get_order_info;	
  			$count=0;
  			foreach $file (@validlist)
  			{
    				system "chmod 750 $file";
    				open(ORDERFILE, "<$file");
    				@orders = <ORDERFILE>;
    				close(ORDERFILE);
    				system "chmod $security $file";
    				foreach $order_x (@orders)
    				{
      					@data = split(/\|/, $order_x);
      					$date_time = $data[1];
      					($order_date, $order_time) = split(/\@/, $date_time);
      					($year,$mon,$day) = split(/-/, $order_date);
      					if ($data[0] =~ $aff_num || $aff_num eq "ALL") 
      					{
						for ($i=0; $i<12; $i++)
        					{
          						if ($months[$i] =~ $mon) {$mon_num = $i; last;}
        					}
        					if ($year==$startyear && $mon_num==$start_month_num && $day<$startday) { 1;}
        					elsif ($year == $endyear && $mon_num == $end_month_num && $day > $endday) { 1; }
        					else 
						{
							@return_data=&printorder;
							if ($FORM{'format'} eq "detailed")
							{
		  	  					@data = @return_data;
		  	  					splice(@data,11,1);
		  	  					open(TMPFILE,"<$log_dir/db_temp.txt");
				      				@data2 = <TMPFILE>;
				      				close(TMPFILE);
      								$xx = 0;
			      					for (@data2)
			      					{
			      						@data4 = split(/;\|;/,$_);
			      						#@data3 = @data;
			      						#$d3count = 0;
			      						#foreach $value (@data3)
			      						#{
			      						#	print "$d3count = $value<BR>\n";
			      						#	$d3count++;
			      						#}
			      						@data3 = ($data[0],$data[1],$data[2],$data[10],$data[15]); #date,affnum,name,email,ip_address
			      						push @data3,@data4;
      									if ($xx)
      									{
	      									@data3 = &re_order_array(\@data3,\@order,\@no_dup);
      									}
      									else
      									{
      										@data3 = &re_order_array(\@data3,\@order,\@null_array);
      									}
      									&print_db_data(@data3);
			      						$xx ||= 1;
			      					}
							}
							else
							{
								@data = &re_order_array(\@return_data,\@order,\@null_array);
								&print_db_data(@data);
							} 
						}
      					}# end of $dealernum match
    				}#end of each $order in @orders	
  			}#end of each $file in @validlist;
  		}
  		&close_db_file;
  		&download_file($filename);
	}
	elsif ($FORM{'B_SUB'} =~ /SAVE/)
	{
		$x = scalar(@labels);
		@order = ();
		for ($y=1;$y<=$x;$y++)
      		{
      			$u = 1;
      			for (@labels)
      			{
      				$label_name = $_;
      				push @order,$u if ($FORM{$y} eq $label_name);      		
      				$u=$u+1;
      			}
      			
      		}
      		
      		$u = 0;
      		for (@labels)
      		{
      			$label_name = $_;
			$order[$u] = 0-$order[$u] if ($FORM{$label_name} ne "on");
      			$u=$u+1;	
      		}
      		unless ($FORM{'format_save'} eq "")
		{
			open (FILE,">$log_dir/$FORM{'format_save'}$file_ext");
			for (@order)
			{
				print FILE "$_\n";
			}
			close (FILE);
		}
		&start_url;
  		&draw_dbase_table(\@labels,$file_ext,$call_func,\@order);
  		exit;
	}
	elsif ($FORM{'B_SUB'} =~ /LOAD/)
	{
		open (FILE,"<$log_dir/$FORM{'format_load'}$file_ext");
		@order = <FILE>;
		close(FILE);
		&start_url;
  		&draw_dbase_table(\@labels,$file_ext,$call_func,\@order);
  		exit;
  	}
	else 
	{
		&default;
	}

	exit;
}


sub draw_dbase_table
#calling this routine requires a list of labels, a calling function to return to if cancel,
#and a file extension type to load and save pre-formatted files.
{
	my ($labels_r,$file_ext,$call_func,$num_array_r) = @_;
	my @labels = @$labels_r;
	my @num_array = @$num_array_r;
	my $x;
	my $y;
	my $label_name;
	my $column;
	my $dirfiles;
	my $exist;
	
	$column=1;
	print "<center>";
	print "<form method=\"POST\" action=\"$call_func\">";
	print "<p>Using the table below, organize the output file by choosing the<br>\ncolumn number";
	print " for each of the fields (labels) in the database.<br>\n<br>\n";
	print "If you do not want to include a particular field,<br>uncheck the box next to the label name.</p>";
	opendir (THISDIR,"$log_dir");
	@dirfiles = readdir THISDIR;
	closedir(THISDIR);
	$exist = 0;
	for (@dirfiles)
	{
	 	$exist=1 if (/$file_ext$/)
	}
	if ($exist)
	{
		print "To load a pre-existing layout,<br>choose from one of the following: ";
		
		print "<select name=\"format_load\" size=\"1\">";
		@dirfiles = sort {lc($a) cmp lc($b)} @dirfiles;
		for (@dirfiles)
		{	if (/$file_ext$/)
			{
			 	s/$file_ext$//;
				print "<option>$_</option>";
			}
		}
		print "</select><br>\n";
		print "and press the ";
		print "<input type=\"submit\" name=\"B_SUB\" value=\"LOAD FILE FORMAT\">";
		print " button.<br>\n<br>\n";
	}
	print "<table border=\"1\">";
	print "<tr><td rowspan=\"2\" align=\"center\"><strong><font size=\"3\">Labels</font></strong></TD>";
	$x = scalar(@labels);
	$y = $x+1;
	print "<td colspan = \"$y\" align=\"center\"><strong>Column Number</strong></td></tr>";
	print "<tr>";
	for ($y=1;$y<=$x;$y++)
	{
		print"<td align=\"center\"><strong><font size=\"2\">$y</font></strong></td>"; 
	}
	print "</tr>";
	$z = 1;
	foreach (@labels)
	{
		$label_name = $_;
		print"<tr><td align=\"left\"><font size=\"2\">";
		print "<input type=\"checkbox\" name=\"$label_name\"";
		print " checked" if ($num_array[$z-1]>0);
		print ">$label_name</font></td>";
		for ($y=1;$y<=$x;$y++)
		{
			print"<td align=\"center\"><font size=\"2\">";
			print"<input type=\"radio\" name=\"$y\" value=\"$label_name\"";
			print " checked" if (abs($num_array[$y-1])==$z);
			print "></font></td>"; 
		}
		print "</tr>";
		$z=$z+1;
	}
	print "</table>";
	print "<p>You may save the above layout for future use<br>by typing a filename here: ";
	print "<input type=\"text\" name =\"format_save\" size=\"10\">";
	print "<br>\nand pressing the ";
	print "<input type=\"submit\" name=\"B_SUB\" value=\"SAVE FILE FORMAT\">";
	print " button.</p>";
	print "<p>You may choose to organize the output file as follows:<br>\n";
	print "<table border = \"0\">";
	print "<tr><td align = \"center\">";
	print "<input type=\"radio\" name=\"delim_type\" value=\"comma\" checked></td>";
	print "<td align = \"left\">";
	print "Data saved in comma separated format.</td></tr>\n"; 
	print "<tr><td align = \"center\">";
	print "<input type=\"radio\" name= \"delim_type\" value=\"tab\"></td>";
	print "<td align = \"left\">";
	print "Data saved in tab separated format.</td></tr>\n";
	print "</table>";
	print "Select one of the following:<br><input type=\"submit\" name=\"B_SUB\" value=\"DOWNLOAD FILE\"> ";
	print "<input type=\"hidden\" name=\"password\" value=\"$password\">";
	print "<input type=\"hidden\" name=\"report\" value=\"$report\">";
	print "<input type=\"hidden\" name=\"format\" value=\"$FORM{'format'}\">";
	print "<input type=\"hidden\" name=\"aff_num\" value=\"$aff_num\">";
	print "<input type=\"hidden\" name=\"keyword\" value=\"$FORM{'keyword'}\">";
	print "<input type=\"hidden\" name=\"month\" value=\"$FORM{'month'}\">";
	print "<input type=\"hidden\" name=\"year\" value=\"$FORM{'year'}\">";
	print "<input type=\"hidden\" name=\"startday\" value=\"$FORM{'startday'}\">";
	print "<input type=\"hidden\" name=\"startmonth\" value=\"$FORM{'startmonth'}\">";
	print "<input type=\"hidden\" name=\"startyear\" value=\"$FORM{'startyear'}\">";
	print "<input type=\"hidden\" name=\"endday\" value=\"$FORM{'endday'}\">";
	print "<input type=\"hidden\" name=\"endmonth\" value=\"$FORM{'endmonth'}\">";
	print "<input type=\"hidden\" name=\"endyear\" value=\"$FORM{'endyear'}\">";
	print "</form>";
	&make_link_button("RETURN","$call_func");
	print "</center></body></html>";
}

sub open_db_file
{
	my $file_ext;
	if ($FORM{'delim_type'} eq "comma")
	{
		$file_ext = ".csv";
	}
	else
	{
		$file_ext = ".txt";
	}
	
	
	my $filename = "$log_dir/report_data$file_ext";
	open (FILE,">$filename");
	return $filename;
}


sub print_db_labels
{
	my (@labels) = @_;
	my $dataline = "";
	
	$delim_char = "," if ($FORM{'delim_type'} eq "comma");
	$delim_char = "\t" if ($FORM{'delim_type'} eq "tab");

	for(@labels)
	{
		s/\n//g;
		if ((/$delim_char/)||(/\W/))
		{
			s/\"/\"\"/;
			if ($dataline eq "")
			{
				$dataline = "\"$_\"";
			}
			else
			{
				$dataline = $dataline.$delim_char."\"$_\"";
			}
		}
		else
		{
			if ($dataline eq "")
			{
				$dataline = $_;
			}
			else
			{
				$dataline = $dataline.$delim_char.$_;
			}	
		}
	}
	print FILE "$dataline\n";
}


sub print_db_data
{
	my @data = @_;
	my $delim_char;
	my $dataline="";
	
	$delim_char = "," if ($FORM{'delim_type'} eq "comma");
	$delim_char = "\t" if ($FORM{'delim_type'} eq "tab");
	
	for(@data)
	{
	
		s/\n//g;
		#replaced below commented code with this:
		s/$delim_char/ /g;
		if ($FORM{'delim_type'} eq "comma")
		{
			$dataline = $dataline . $delim_char . "\"$_\""; #put quotes around every field
		}
		else { $dataline = $dataline . $delim_char . $_; }
		
		#if ((/$delim_char/)||(/\W/))
		#{
		#	s/\"/\"\"/;
		#	if ($dataline eq "")
		#	{
		#		$dataline = "\"$_\"";
		#	}
		#	else
		#	{
		#		$dataline = $dataline.$delim_char."\"$_\"";
		#	}
		#	
		#}	
		#else
		#{
		#	if ($dataline eq "")
		#	{
		#		$dataline = $_;
		#	}
		#	else
		#	{
		#		$dataline = $dataline.$delim_char."\"$_\"";
		#	}
		#}
	}
	$dataline =~ s/^$delim_char//;
	print FILE "$dataline\n";	
}

sub close_db_file
{
	close FILE;
}


sub download_file
{
	my ($filename) = @_;
	if (-e "$filename")
	{
		print "Content-type: application/yoapdb\n\n";	
		open (FILE,"<$filename");
		while (<FILE>)
		{
			s/_/ /g;
			print "$_";
		}
		close (FILE);
		system "rm $filename";
		
	}
	
}


sub re_order_array
{
	my ($data_r,$order_r,$no_dup_r) = @_;
	my @data = @$data_r;
	my @order = @$order_r;
	my @no_dup = @$no_dup_r;
	my @new_data = ();
	my $x;
	my $y;
	my $z;

	for (@order)
	{
		$x = $_;
		$y = $x-1;
		$z = 0;
		for (@no_dup)
		{
			$z = 1 if ($x==$_);
		}	
		if ($z)
		{
			push @new_data," ";
		}
		else
		{
			push @new_data,$data[$y];
		}
	}
	
	return @new_data;
}


sub order_data
{
	my @l = @_;
	my $x=scalar(@l);
	my $ind = 1;
	my @o = ();
	my $y;
	my $z;
	for ($y=1;$y<=$x;$y++)
	{
		$z=1;	
      		for (@l)
      		{
      			$l_name = $_;
      			if ($FORM{$y} eq $l_name)
      			{
      				push @o,$z if ($FORM{$l_name} eq "on");
      			}
			$z=$z+1;
      		}
      	}
      	
      	
      	return @o;
}


sub get_db_month
{
	my @d = ();
	my $x;


 	$transactions_exist = 1;
        $transactions_exist = &check_transactions();
	if ($transactions_exist)
	{
      		@d = &get_comm_info;
		if ($FORM{'format'} eq "detailed")
      		{
      			$x = $d[0];
      			open(TMPFILE,"<$log_dir/db_temp.txt");
      			@d = <TMPFILE>;
      			close(TMPFILE);
      			push @d,$x;
   		}
   		
   	} 
	return @d;
}

1;
