#!/usr/bin/perl
################################################################################
#
# This Perl program code COPYRIGHT 2005 Paul Galloway. All Rights Reserved.
# Program may not be sold or distributed except by express written permission
# of the author.
#
# The use of any part of this program or any code segments from it for any
# purpose, personal or commercial, is forbidden except by express written 
# permission of Paul Galloway.
#
# You may contact the author at the following email address:
#
# Email: paulg@paulgalloway.com
#
##############################################################################

unshift (@INC, ".");
require (options);
open(STDERR, ">errors/dealers.errors");
system "chmod 777 $originals_dir";
system "chmod 777 $clone_root";
system "chmod 777 $log_dir";
system "chmod 777 $temp_dir";
system "chmod 777 $ip_dir";
require (dbase_out);

$cgi_script = $cgi_url . "/dealers.cgi";
$cgi_script2 = $cgi_url . "/report.cgi";
@months=("January","February","March","April","May","June","July","August","September","October","November","December");


&get_input;
if ($new_password ne "")
{
  &start_url;
  &change_password;
  exit;
}

&check_password;

my @dummy=();

&default if ($report eq "");

if ($FORM{'B_SUB'} =~ /FILE/)
{	
	&dbase_out($cgi_script);
	exit;
}

if ($report eq "listkey")
{
   if ($keyword eq "")
   {
      &start_url;
      print "<BLOCKQUOTE><B>Sorry, but you didn't supply any keyword to search for.<P>\n";
      print "Please hit the \"BACK\" button and enter a keyword.</B></BLOCKQUOTE></BODY></HTML>";
      exit;
   }
   
   $dealerfile = $log_dir . "/" . $file_prefix . "-dealers.txt";
   system "chmod 666 $dealerfile";
   open (DFILE, "<$dealerfile");
   while (<DFILE>)
   {
     ($name, $lastname, $email, $address1, $address2, $city, $state, $zip, $phone, $country, $aff_num_level, $trash) = split(/\|/);
     ($aff_num, $level) = split(/\-/, $aff_num_level);
     if ($name =~ "-DELETED-") { delete $num_vs_data{$aff_num}; }
     else
     {
       if ($_ =~ $keyword) { s/\-UPDATE\-//g; $num_vs_data{$aff_num} = $_;}
     }
   }
   close(DFILE);
   system "chmod $security $dealerfile";
   @sorted = sort { $a <=> $b } (keys %num_vs_data);
   $total = @sorted;
   &write_filepass;
   &start_url;
   print "<CENTER><B>A total of $total matches were found and are shown below. . .</B></CENTER><HR>";
   print "<CENTER><TABLE BORDER=1  CELLPADDING=5 CELLSPACING=0 BORDERCOLOR=\"\#000000\"><TR><TD align=\"center\">Number</TD><TD align=\"center\">Name</TD><TD align=\"center\">State</TD><TD align=\"center\">Country</TD><TD align=\"center\">Phone</TD></TR>\n";
   foreach $dnum (@sorted)
   {
     ($dealer_name,$dealer_email,$address1,$suite,$city,$state,$zip,$phone,$country,$dn,$pw,$longdate,$ip,$cb1,$cb2,$c1,$c2,$c3,$c4,$c5,$dealer_url,$dealer_ul) = split (/\|/, $num_vs_data{$dnum});
     ($aff_num, $level) = split(/\-/, $dn);
     $dealer_name =~ s/\-UPDATE\-//g;
     $dealer_name = substr($dealer_name, 0, 35);
     print "<TR><TD align=\"center\">$dnum</TD><TD align=\"center\"><A HREF=\"$cgi_script2\?filepass=$filepass\&report=getaffiliateinfo\&dealernum=$dnum\">$dealer_name</A></TD><TD align=\"center\">$state</TD><TD align=\"center\">$country</TD><TD align=\"center\">$phone</TD></TR>\n";
   }
   print "</TABLE></CENTER><P>";
   print "</BODY></HTML>";
   exit;
}


if (($report =~ /list/)||($report eq "sendemail"))
{
	&start_url if ($report =~ /list/);
  	$mailaddr = "" if $report eq "sendemail";
  	if ($report eq "list") { print "<TABLE WIDTH=90% BORDER=1 CELLPADDING=5 CELLSPACING=0 BORDERCOLOR=\"\#000000\">";}
  	if ($aff_num eq "ALL" && $report eq "listmod")
  	{
    		print "<P>Sorry, but you must specify an affiliate number for this function.";
    		print "Please hit the \"BACK\" key and enter a valid affiliate number.";
    		print "</BODY></HTML>";
    		exit;
  	}
  	if ($aff_num eq "ALL" )
  	{
    		&get_dealers;
    		foreach $aff_num(@dealers)
    		{ 
      			@dummy = &get_list_info;
    		}
}
else 
{
	@dummy = &get_list_info;
}
  
&deal_s_email if $report eq "sendemail";
  
if ($report eq "list") { print "</TABLE>"; }
print "</BODY></HTML>" if ($report =~ /list/);
exit;
}
elsif ($report eq "monthcomm" || $report eq "yearcomm")
{
	&start_url;
  	for ($i=0; $i<12; $i++)
  	{
    		if ($months[$i] eq $FORM{'month'}) 
    		{ 
      			$query_month = $i;
      			last;
    		}
  	}

  	if ($aff_num eq "ALL")
  	{
    	  &get_dealers; #get all existing dealer numbers
    	  foreach $aff_num(@dealers)
    	  { 
	    if ((&get_info_file) && ($dealer_done{$aff_num} ne "YES"))
	    {
	      @dummy = &get_dealer_info;
	      print "<HR>Commission Report for affiliate number $aff_num\:<P>";
	      #if ($FORM{'fullinfo'} eq "YES") 
	      #{ 
	      #  print "$name<BR>\n$address1<BR>\n$suite<BR>\n$city\,$state $zip<BR>\n$country<BR>Phone:$phone<P>Home URL: <A HREF=\"$dealer_url\">$dealer_url</A><BR>Comments: $c2<P>"; 
	      #}
              #else 
              #{ 
              	if ($suite ne "") { $suitestring = "$suite<BR>\n"; }
              	else {$suitestring = ""; }
                print "$name $lastname<BR>\n$address1<BR>\n$suitestring$city\,$state $zip<BR>\n$country<BR>$phone<BR>$email<P>"; 
              #}
              &get_comm_info;
              $dealer_done{$aff_num} = "YES";
            }
          }
    	}
    	else 
  	{ 
    		if (&get_info_file)
    		{
      			@dummy = &get_dealer_info;
      			print "Commission Report for affiliate number $aff_num\:<P>";
      			if ($FORM{'fullinfo'} eq "YES") { print "$name $lastname<BR>\n$address1<BR>\n$suite<BR>\n$city\,$state $zip<BR>\n$country<BR>Phone:$phone<P>Home URL: <A HREF=\"$dealer_url\">$dealer_url</A><BR>Comments: $c2<P>"; }
                        else { print "$name $lastname<BR>\n$address1<BR>\n$suite<BR>\n$city\,$state $zip<BR>\n$country<P>"; }
                        &get_comm_info;	
    		}
    		else 
    		{ 
	      		print "Sorry, there is no information for that affiliate number . . .";
    		}
  	}
  	print "</BODY></HTML>";
  	exit;
}
elsif ($report eq "disable")
{
   &disable_account;
}
elsif ($report eq "enable")
{
   &enable_account;
}
else {&default;}


sub check_transactions
{
	my $te=0;  	
  	if ($report eq "monthcomm")
  	{
    		$orderfile = $ord_dir . "/" . $aff_num . "-" . $query_year . "-";
    		$orderfile .= "0" if ($query_month < 10);
    		$orderfile = $orderfile . $query_month . ".ord";
    		$te = 1 if (-e $orderfile);
  	}
  	else
  	{ 
	    	@files = "";
    		$trash = shift(@files);
    		for ($tempmonth=0; $tempmonth < 12; $tempmonth++)
    		{
      			$neworderfile = $ord_dir. "/" . $aff_num . "-" . $query_year . "-";
      			if ($tempmonth < 10) { $neworderfile .= "0" };
      			$neworderfile .=  $tempmonth . ".ord";
      			$te = 1 if (-e $neworderfile); 
    		}
    	}
    	return $te;	
}



sub get_comm_info
{
	my @data=();
  	if ($report eq "monthcomm")
  	{
    		$orderfile = $ord_dir . "/" . $aff_num . "-" . $query_year . "-";
    		if ($query_month < 10) { $orderfile .= "0"; }
    		$orderfile = $orderfile . $query_month . ".ord";

    		if (-e $orderfile)
    		{ 
      			@data = &report_month;
    		}
    		else 
    		{
    			if (($FORM{'B_SUB'} =~ /BROWSER/)||($FORM{'B_SUB'} =~ /INFORMATION/))	
  			{
    				print "No orders for $months[$query_month] for this affiliate...<BR>\n";
    			}
    		}
	}
	elsif ($report eq "yearcomm")
  	{
    		@files = "";
    		$trash = shift(@files);
  	  	for ($tempmonth=0; $tempmonth < 12; $tempmonth++)
    		{
      			$neworderfile = $ord_dir . "/" . $aff_num . "-" . $query_year . "-";
      			if ($tempmonth < 10) { $neworderfile .= "0" };
      			$neworderfile .=  $tempmonth . ".ord";
      			if (-e $neworderfile)
      			{
	        		push (@files, $neworderfile);
      			}
      		}
    		$total_comm = 0;
    		$total_quantity = 0;
    		foreach $file (@files)
    		{  
	       		chop $file if ($file =~ /\n$/);
       			$orderfile=$file;
       			$monthly_comm = 0;
       			@dummy = &report_month;
       			$total_comm += $monthly_comm;
       			$total_quantity += $monthly_quantity;
    		}
                $total_comm = sprintf ("%04.2f", $total_comm);	
    		if (($FORM{'B_SUB'} =~ /BROWSER/)||($FORM{'B_SUB'} =~ /INFORMATION/))	
  		{
    			print "<P><B>Total Items Sold: $total_quantity<BR>\nTotal Commissions: $total_comm</B>";
    		}	
  	} 	
  	else
  	{ 
    		&start_url;
    		print "An invalid report was requested . . .<BR>\n";
    		print "Report code was $report . . .";
    		print "</BODY></HTML>";
    		exit;
  	}
  	
  	return @data;
}


sub bad_dealernum
{
  &start_url;
  print "A match couldn't be found for that affiliate number. <P>Please click on the \"BACK\" button and be sure you have entered the information correctly.";
  print "</BODY></HTML>";
  exit;
}

sub get_input
{
  my $buffer;
  my $key;
  
  $FORM=();
  	
  if ($ENV{'REQUEST_METHOD'} eq "GET")
  {
    $buffer=$ENV{'QUERY_STRING'};
  }
  else 
  {
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
  }

  @pairs = split(/&/, $buffer);
  foreach $pair (@pairs) 
  {
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/<!--(.|\n)*-->//g;
    $value =~ s/\|/ /g;
    $FORM{$name} = $value;
  }
	foreach $key (keys %FORM)
	{
		$FORM{$key} =~ tr/\&\;\`\'\\\"\|\*\?\~\<\>\^\(\)\[\]\{\}\$\n\r/                      /;
	}
  
  $FORM{'report'} = "writeemail" if (exists $FORM{'B5'});
  if (exists $FORM{'B_SEND'})
  {
  	$FORM{'report'} = "sendemail";
  	$body = $FORM{'body'};
  	$subject = $FORM{'subject'};
  	$FORM{'dealernum'} = "ALL";
  }
  
  $aff_num = $FORM{'dealernum'};
  $aff_num =~ s/all/ALL/i;
  $aff_num =~ s/ //g;
  if ($aff_num eq "") {$aff_num = "ALL";}
  $password = $FORM{'password'};
  $password =~ s/ //g;
  $report = $FORM{'report'};
  $new_password = $FORM{'newpass'};
  $old_password = $FORM{'oldpass'};
  $query_year = $FORM{'year'};
  $zero_transactions = $FORM{'zeroes'};
  $keyword = $FORM{'keyword'};
  
}


sub report_month
{
	my @data = ();
  	system "chmod 777 $orderfile";
  	open(ORDERFILE, "<$orderfile");
  	@orders=<ORDERFILE>;
  	system "chmod $security $orderfile";
  	close (ORDERFILE);
  	$year = substr($orderfile, -11, 4);
  	$mon = substr($orderfile, -6, 2);
  	$month = $months[$mon];
  	$monthly_comm = 0;
  	$monthly_quantity = 0;
      	
  	if (($FORM{'B_SUB'} =~ /BROWSER/)||($FORM{'B_SUB'} =~ /INFORMATION/))	
  	{
    	    		
  		if ($FORM{'format'} eq "detailed")
  		{
  			print "<CENTER><FONT COLOR=\"FF0000\" SIZE=4><B>$month\, $year</B></FONT></CENTER>";
    		}
  	}
 	open(TMPFILE,">$log_dir/db_temp.txt") if ($FORM{'format'} eq "detailed");
  	foreach $order (@orders)
  	{
    		chop $order if ($order =~ /\n$/);
    		($first,$middle,$last) = split(/\|\;\;\|/, $order);
    		($dealer, $date) = split(/\|/, $first);
    		@items = split(/\|/, $middle);
    		$date_printed = 0;
    		foreach $item (@items)
    		{ 
      			($product, $price, $quantity, $total, $commission) = split(/\:\:/, $item);
      			if ($FORM{'format'} eq "detailed")
      			{
      				if (($FORM{'B_SUB'} =~ /BROWSER/)||($FORM{'B_SUB'} =~ /INFORMATION/))	
      				{
      					$date="" if ($date_printed);   
					print "Date: $date\&nbsp;\&nbsp;Product: $product\&nbsp;\&nbsp;Quantity: $quantity\&nbsp;\&nbsp;Commission: $commission<BR>\n";
      				}
      				else
      				{
      					print TMPFILE "$date;|;$product;|;$price;|;$quantity;|;$commission\n";
      				}
      			}
      			$monthly_quantity += $quantity;
      			$monthly_comm += $commission;
	      		$date_printed++;
    		}
  	}
  	close (TMPFILE) if ($FORM{'format'} eq "detailed");
        $monthly_comm = sprintf ("%04.2f", $monthly_comm);
  	if ($FORM{'format'} eq "detailed") 
  	{
  		if (($FORM{'B_SUB'} =~ /BROWSER/)||($FORM{'B_SUB'} =~ /INFORMATION/))	
      		{
  			print "<BR>\nTotal for Month: $monthly_comm" if ($monthly_comm != 0);
  			print "<CENTER><B>(No Activity This Month)</B></CENTER>" if ($monthly_comm == 0);
  		}
  		@data = ($monthly_comm); 
  		
  	}
  	if ($FORM{'format'} eq "abbreviated") 
  	{
  		if (($FORM{'B_SUB'} =~ /BROWSER/)||($FORM{'B_SUB'} =~ /INFORMATION/))
  		{
    			print "Month: $month\&nbsp;\&nbsp; Transactions: $monthly_quantity\&nbsp;\&nbsp; Commission: $monthly_comm<BR>\n";
  		}
  		@data = ($month,$monthly_quantity,$monthly_comm);
  
  	}
  	return @data;
  	
}


sub get_dealers
{
  opendir(DEALERDIR, "$nfo_dir");
  @dealer_info_files = grep(/\.nfo/, readdir(DEALERDIR));
  closedir(DEALERDIR);
  foreach $dealer_info_file (@dealer_info_files)
  {
  	my $dnum = $dealer_info_file;
  	$dnum =~ s/\.nfo//;
  	push (@dealers, $dnum);
      	$dealer_hash{$dnum}="0";
  }
  if ($report eq "monthcomm") #this routine makes sure we only look at a dealer's directory if they had an order this month
  {
    $master_dealer_file = $log_dir . "/" . $file_prefix . "-dealers.txt";
    system "chmod 755 $master_dealer_file";
    open (MASTERDEALER, "<$master_dealer_file"); #build hash of dealers / sponsors
    @dealerdata = <MASTERDEALER>;
    close(MASTERDEALER);
    system "chmod $security $master_dealer_file";
    foreach $line (@dealerdata)
    {
      chomp $line;
      @fields = split(/\|/, $line);
      $dsfield = $#fields;
      $dealer_and_level = $fields[10];
      ($dealer, $trash) = split(/\-/, $dealer_and_level);
      $dealer_sponsor_extended = $fields[$dsfield];
      ($dealer_sponsor, $trash) = split (/\!/, $dealer_sponsor_extended);
      $dealer_sponsor =~ s/\s//g;
      $dealer_sponsor_hash{$dealer} = $dealer_sponsor;
    }
    $orderfile = $log_dir . "/" . $file_prefix . "-" . $query_year . "-";
    $orderfile .= "0" if ($query_month < 10);
    $orderfile = $orderfile . $query_month . ".ord";
    system "chmod 755 $orderfile";
    open(ORDERFILE, "<$orderfile");
    while(<ORDERFILE>)
    {
      ($num1, $trash) = split(/\-/, $_);
      ($num, $trash) = split(/\!/, $num1); #in case extended tracking being used
      if (exists $dealer_hash{$num}) {$dealer_hash{$num} = 1;} 
    } #they got an order this month and they still have an account  
    close(ORDERFILE);
    system "chmod $security $orderfile"; 
    
    foreach $aff_num (keys (%dealer_hash))
    {
      if ($dealer_hash{$aff_num} == 1)
      {
    	push(@dealers_with_orders, $aff_num);
    	if (exists $dealer_sponsor_hash{$aff_num}) # dealer $aff_num has a sponsor
    	{
    	  $orderfile = $ord_dir . "/" . $dealer_sponsor_hash{$aff_num} . "-" . $query_year . "-";
    	  $orderfile .= "0" if ($query_month < 10);
    	  $orderfile = $orderfile . $query_month . ".ord";
    	  if (-e $orderfile) 
    	  { 
    	    push(@dealers_with_orders, $dealer_sponsor_hash{$aff_num});
    	  } #sponsor gets a commission too
    	}
      }
    }
    foreach $aff_num (@dealers_with_orders) { $dealers_with_orders{$aff_num} = 1; }
    #get rid of duplicate dealer number -- could happen if multiple affiliates with same sponsor get an order
    @dealers = sort {$a <=> $b} (keys %dealers_with_orders);
  }
}


sub get_info_file
{
  my $valid = 0;
  $info_file = $nfo_dir . "/" . $aff_num . ".nfo";
  $valid = 1 if (-e $info_file );
  return $valid;
}


sub get_dealer_info
{
  	system "chmod 777 $info_file";
  	open(DEALERFILE, "<$info_file");
  	@lines=<DEALERFILE>;
  	close(DEALERFILE);
  	system "chmod $security $info_file";
  	$dataline=$lines[2];
  	if ($dataline =~ /\n$/ ) {chop $dataline;}
  	($name,$lastname,$email,$address1,$suite,$city,$state,$zip,$phone,$country,$dn,$pw,$ld,$ip,$cb1,$cb2,$c1,$c2,$c3,$c4,$c5,$dealer_url,$ul) = split (/\|/, $dataline);
  	my @data = ($name,$lastname,$email,$address1,$suite,$city,$state,$zip,$phone,$country,$dn,$pw,$ld,$ip,$cb1,$cb2,$c1,$c2,$c3,$c4,$c5,$dealer_url,$ul);
 	return @data; 
}


sub get_list_info
{
	my @data =();
  	if (&get_info_file)
  	{
    		@dummy = &get_dealer_info;
    		if ($report eq "list" )
    		{
      			$current_url = $clone_url;
      			$current_url =~ s/AFF_NUM/$aff_num/g;
      			if (($FORM{'B_SUB'} =~ /BROWSER/)||($FORM{'B_SUB'} =~ /INFORMATION/))	
      			{
      				print "<TR><TD>$aff_num</A></TD>";
      				print "<TD>$name $lastname</TD><TD><A HREF=\"mailto:$email\">$email</A></TD></TR>";
      			}
      			else
      			{
      				@data = ($aff_num,$name,$lastname,$email);
      			}	
    		}
    		elsif ($report eq "listall" )
    		{
    			if (($FORM{'B_SUB'} =~ /BROWSER/)||($FORM{'B_SUB'} =~ /INFORMATION/))	
      			{
    				print "<PRE>";
	      			print "First Name:       $name\n";
	      			print "Last Name:        $lastname\n";
      				print "Address:          $address1\n";
      				print "Suite:            $suite\n";
	      			print "City,State,Zip:   $city\,$state $zip\n";
      				print "Country:          $country\n";
      				print "Phone:            $phone \n";
      				print "Email:            $email\n";
      				print "Home URL:	       $dealer_url\n\n";
      				print "Affiliate Number: $aff_num\n";
      				print "Affiliate Level:  $lines[1]\n";
      				print "Password:         $pw\n";
      				print "Signup Date:      $ld\n";
      				print "IP Address:       $ip\n";
      				print "Checkbox1:        $cb1\n";
      				print "Checkbox2:        $cb2\n";
      				print "Custom1:          $c1\n";
      				print "Custom2:          $c2\n";
      				print "Custom3:          $c3\n";
      				print "Custom4:          $c4\n";
      				print "Custom5:          $c5\n";
      				print "Sponsor:          $ul\n";
      				print "</PRE><HR>\n";
      			}
      			else
      			{
      				@data = ($name,$lastname,$address1,$suite,$city,$state,$zip,$country,
      				$phone,$email,$dealer_url,$aff_num,$lines[1],
      				$pw,$ld,$ip,$cb1,$cb2,$c1,$c2,$c3,$c4,$c5,$ul);
      				
      			}
    		} 
    		elsif ($report eq "listmod" )
    		{ 
      			print "<FORM METHOD=\"POST\" ACTION=\"$cgi_url/dealmod.cgi\">";
      			print "<TABLE>\n";
      			print "<TR><TD>First Name:</TD><TD><INPUT NAME=\"name\" TYPE=\"text\" SIZE=20 VALUE=\"$name\"></TD>";
      			print "<TR><TD>Last Name:</TD><TD><INPUT NAME=\"lastname\" TYPE=\"text\" SIZE=20 VALUE=\"$lastname\"></TD>";  			
      			print "<TD>Phone:</TD><TD><INPUT NAME=\"phone\" TYPE=\"text\" SIZE=20 VALUE=\"$phone\"></TD></TR>";
      			print "<TR><TD>Address:</TD><TD><INPUT NAME=\"address1\" TYPE=\"text\" SIZE=20 VALUE=\"$address1\"></TD>";
      			print "<TD>Email:</TD><TD><INPUT NAME=\"email\" TYPE=\"text\" SIZE=20 VALUE=\"$email\"></TD></TR>";
      			print "<TR><TD>Suite:</TD><TD><INPUT NAME=\"suite\" TYPE=\"text\" SIZE=20 VALUE=\"$suite\"></TD>";
      			print "<TD>Home URL:</TD><TD><INPUT NAME=\"url\" TYPE=\"text\" SIZE=20 VALUE=\"$dealer_url\"></TD></TR>";
      			print "<INPUT TYPE=\"hidden\" NAME=\"aff_num\" VALUE=\"$aff_num\">";
      			print "<TR><TD>City:</TD><TD><INPUT NAME=\"city\" TYPE=\"text\" SIZE=20 VALUE=\"$city\"></TD>";
      			print "<TD>Affiliate Number:</TD><TD>$aff_num</TD></TR>";
 	    		print "<TR><TD>State:</TD><TD><INPUT NAME=\"state\" TYPE=\"text\" SIZE=20 VALUE=\"$state\"></TD>";
      			chop $lines[1] if ($lines[1] =~ /\n$/);
      			print "<TD>Affiliate Level:</TD><TD><INPUT NAME=\"level\" TYPE=\"text\" SIZE=20 VALUE=\"$lines[1]\"></TD></TR>";
      			print "<INPUT TYPE=\"hidden\" NAME=\"pw\" VALUE=\"$pw\">";
      			print "<TR><TD>Zip:</TD><TD><INPUT NAME=\"zip\" TYPE=\"text\" SIZE=20 VALUE=\"$zip\"></TD>";
      			print "<TD>Password:</TD><TD><INPUT NAME=\"pw\" TYPE=\"text\" SIZE=20 VALUE=\"$pw\"></TD></TR>";
 			print "<TR><TD>Country:</TD><TD><INPUT NAME=\"country\" TYPE=\"text\" SIZE=20 VALUE=\"$country\"></TD>";
      			print "<TD>Signup Date:</TD><TD><INPUT NAME=\"ld\" TYPE=\"text\" SIZE=20 VALUE=\"$ld\"></TD></TR>";
      			print "<TR><TD>Checkbox1:</TD><TD><INPUT NAME=\"cb1\" TYPE=\"text\" SIZE=20 VALUE=\"$cb1\"></TD>";
      			print "<TD>Checkbox2:</TD><TD><INPUT NAME=\"cb2\" TYPE=\"text\" SIZE=20 VALUE=\"$cb2\"></TD></TR>";
      			print "<TR><TD>Custom1:</TD><TD><INPUT NAME=\"c1\" TYPE=\"text\" SIZE=20 VALUE=\"$c1\"></TD>";
      			print "<TD>Custom2:</TD><TD><INPUT NAME=\"c2\" TYPE=\"text\" SIZE=20 VALUE=\"$c2\"></TD></TR>";
      			print "<TR><TD>Custom3:</TD><TD><INPUT NAME=\"c3\" TYPE=\"text\" SIZE=20 VALUE=\"$c3\"></TD>";
      			print "<TD>Custom4:</TD><TD><INPUT NAME=\"c4\" TYPE=\"text\" SIZE=20 VALUE=\"$c4\"></TD></TR>";
      			print "<TR><TD>Custom5:</TD><TD><INPUT NAME=\"c5\" TYPE=\"text\" SIZE=20 VALUE=\"$c5\"></TD>";
      			print "<TD>IP Address:</TD><TD><INPUT NAME=\"ip\" TYPE=\"text\" SIZE=20 VALUE=\"$ip\"></TD></TR>";
      			print "<TR><TD>Sponsor:</TD><TD><INPUT NAME=\"ul\" TYPE=\"text\" SIZE=20 VALUE=\"$ul\"></TD></TR>";
      			print "</TABLE><HR><CENTER>";
      			print "<INPUT TYPE=\"radio\" NAME=\"action\" CHECKED VALUE=\"update\">Update this affiliate information<BR>";
      			print "<INPUT TYPE=\"radio\" NAME=\"action\" VALUE=\"delete\">Delete this affiliate website and record <BR>";
      			print "<INPUT TYPE=\"checkbox\" NAME=\"confirmed\" VALUE=\"YES\">Check this box to confirm that you want to DELETE this affiliate\'s website and contact information.<P>";
      			print "<INPUT TYPE=\"hidden\" NAME=\"password\" VALUE=\"$password\">";
      			print "<INPUT TYPE=\"submit\" VALUE=\"<<<<< UPDATE/DELETE RECORD >>>>>\">";
      			print "</CENTER><HR>";
    		}
    		elsif ($report eq "sendemail")
    		{
    			if ($mailaddr eq "")
    			{
    				$mailaddr = $email;
    			}
    			else
    			{
    			$mailaddr = $mailaddr.";\|;$email";
    			}
    	
    		}
    		else  #assume simple mailing list
    		{
    			if (($FORM{'B_SUB'} =~ /BROWSER/)||($FORM{'B_SUB'} =~ /INFORMATION/))	
      			{	
      				print "<P>$name $lastname<BR>$address1<BR>";
      				print "$suite<BR>" if ($suite ne ""); 
      				print "$city\,$state $zip<BR>";
      				print "$country" if ($country ne "" );
      		      	}
      		      	else
      			{
      				@data = ($name,$lastname,$address1,$suite,$city,$state,$zip,$country);
      			}	
    		}
  	}
  	else { print "Sorry, there is no information for that affiliate number . . .";}
  	
  	return @data;
}


sub default
{
  &start_url;
  print "<CENTER><H2>Affiliate Contact and Commission Information</H2></CENTER>\n";
  print "<HR><FONT SIZE=3><B>";
  print "<FORM ACTION=\"$cgi_script\" METHOD=\"POST\"><input type=\"hidden\" name=\"password\" value=\"$password\">";
  print "<TABLE>\n";
  print "<TR><TD><B>Affiliate You Want to Generate  Reports For:</TD>";
  print "<TD><INPUT TYPE=\"text\" NAME=\"dealernum\" SIZE=20 VALUE=\"$aff_num\">";
  print "<B>(\"ALL\" = all affiliates.)</TD></TR></TABLE><P>";
  print "<BLOCKQUOTE>\n";
  print "<INPUT TYPE=\"radio\" NAME=\"report\" VALUE=\"listmod\">Modify or delete affiliate information and site <FONT SIZE=2 COLOR=\"0000FF\">(You must specify affiliate number above.)</FONT><BR>";
  print "<INPUT TYPE=\"radio\" NAME=\"report\" VALUE=\"disable\"><B><FONT COLOR=\"\#FF0000\">Disable</FONT></B> affiliate account<FONT SIZE=2 COLOR=\"0000FF\"> (You must specify affiliate number above.)</FONT><BR>";
  print "<INPUT TYPE=\"radio\" NAME=\"report\" VALUE=\"enable\"><B><FONT COLOR=\"\#009900\">Enable</FONT></B> affiliate account<FONT SIZE=2 COLOR=\"0000FF\"> (You must specify affiliate number above.)</FONT><P> <P>";

  print "<INPUT TYPE=\"radio\" NAME=\"report\" VALUE=\"maillist\">Mailing List (addresses only)<BR>";
  print "<INPUT TYPE=\"radio\" NAME=\"report\" CHECKED VALUE=\"list\">Affiliate List (Affiliate(s) Number, Name, Email -- with hyperlinks)<BR>";
  print "<INPUT TYPE=\"radio\" NAME=\"report\" value=\"listkey\">Keyword Affiliate List. Enter keyword: <INPUT TYPE=\"text\" name=\"keyword\" size=\"20\"> <FONT SIZE=2 COLOR=\"0000FF\">(Affiliate number ignored)</FONT><BR>";
  print "<INPUT TYPE=\"radio\" NAME=\"report\" VALUE=\"listall\">All logged info on affiliate(s)<BR>";
  if ($dbase_out)
  {
  	print "<CENTER><INPUT name = \"B_SUB\" TYPE=\"submit\" VALUE=\"   OUTPUT TO BROWSER  \"><BR>";
  	print "<INPUT name = \"B_SUB\" TYPE=\"submit\" VALUE=\"    OUTPUT TO FILE    \"></CENTER>";
  }
  else 
  {
  	print "<CENTER><INPUT name = \"B_SUB\" TYPE=\"submit\" VALUE=\"   GET INFORMATION  \"><BR></CENTER></FORM>";
  }
  print "</BLOCKQUOTE>";
  print "</BODY>\n";
  print "</HTML>\n";
  exit;
}

sub check_password
{
  $passfile = $log_dir . "/" . "password.txt"; 
  if (-e $passfile)
  {
    system "chmod 444 $passfile";
    open(PASSFILE, "<$passfile");
    $master_password = <PASSFILE>;
    close(PASSFILE);
    system "chmod $security $passfile";
    chop $master_password if ($master_password =~ /\n$/);
    $try = crypt ($password, "aa");
    if ($master_password eq $try)
    {
      return;
    }
  }
  
  &start_url;
  print "Sorry, \"$password\" does not match the recorded master password (admin password) -- please hit the \"BACK\" button on your browser and try again.";
  print "</BODY></HTML>";
  exit;
}


sub change_password
{
  $passfile = $log_dir . "/" . "password.txt"; 
  if (-e $passfile)
  {
    system "chmod 444 $passfile";
    open(PASSFILE, "<$passfile");
    $master_password = <PASSFILE>;
    close(PASSFILE);
    system "chmod $security $passfile";
    chop $master_password if ($master_password =~ /\n$/);
    $old = crypt ($old_password, "aa");
    if ($master_password ne $old)
    {
      print "Sorry, the \"old password\" ($old_password) you supplied does not match the recorded master password . . .";
      return;
    }
  }
  system "chmod 777 $passfile";
  open (PASSFILE, ">$passfile");
  $new = crypt ($new_password, "aa");
  print PASSFILE "$new";
  close (PASSFILE);
  system "chmod $security $passfile";
  print "<CENTER>The master password (admin password) has been changed to $new_password.<P>\n";
  print qq^<FORM ACTION="$cgi_url/conpanel.cgi" METHOD="POST">
  <input type="hidden" name="action" value="login">
  <input type="hidden" name="password" value="$new_password">
  <input type="submit" name="submit" value="Login to Control Panel with New Password">
  </FORM></CENTER></BODY></HTML>
  ^;
}


sub write_filepass
{
  $valid_chars="abcdefghijkmnpqrstwxyzABCDEFGHIJKLMNPQRSTWXYZ23456789";
  $seed = srand ( time() ^ ($$ + ($$ << 15)) );
  $filepass = "";
  for ($i=0; $i<8; $i++)
  {
    $randomnumber = int(rand 53);
    $letter = substr($valid_chars,$randomnumber,1);
    $filepass = $filepass . $letter;
  }
  $tempname = $log_dir . "/temp2.txt";
  system "chmod 777 $tempname";
  open(TEMPFILE, ">$tempname"); 
  print TEMPFILE "$filepass\n";
  close(TEMPFILE);
}

sub enable_account
{
   #remove "yoapdisabled.txt" from affiliate directory
   # copy latest index.html (with substitutions) to directory
   $disable_file = $clone_root . "/" . $aff_num . "/yoapdisabled.txt";

   $index_file = $clone_root . "/" . $aff_num . "/index.html.old";
   $index_file2 = $clone_root . "/" . $aff_num . "/index.htm.old";
   $index_file3 = $clone_root . "/" . $aff_num . "/index.shtml.old";

   $new_index = $clone_root . "/" . $aff_num . "/index.html";
   $new_index2 = $clone_root . "/" . $aff_num . "/index.htm";
   $new_index3 = $clone_root . "/" . $aff_num . "/index.shtml";

   $template_file = $originals_dir . "/index.html";
   if (! -e $template_file) { $template_file = $originals_dir . "/index.htm";}
   if (! -e $template_file) { $template_file = $originals_dir . "/index.shtml";}
   $aff_dir = $clone_root . "/" . $aff_num;
   &start_url;
   if (-e $disable_file)
   {
      system "rm $disable_file";
      if (-e $index_file) { system "rm $new_index"; system "cp $index_file $new_index"; system "rm $index_file";}
      if (-e $index_file2) { system "rm $new_index2"; system "cp $index_file2 $new_index2"; system "rm $index_file2";}
      if (-e $index_file3) { system "rm $new_index3"; system "cp $index_file3 $new_index3"; system "rm $index_file3";}
      print "<B>Affiliate account $aff_num has been enabled.</B></BODY></HTML>";
   }
   elsif (-e $aff_dir)
   {
      print "<B>That account was already enabled...no further action is required.</B></BODY></HTML>\n";      
   }
   else
   {
      print "<B>That affiliate account does not exist.</B></BODY></HTML>\n";
   }
   exit;
}


sub disable_account
{
   #create "yoapdisabled.txt" in affiliate directory
   # overwrite index.html
   $disable_html = $log_dir . "/disabled_account_message.txt";
   $disable_file = $clone_root . "/" . $aff_num . "/yoapdisabled.txt";

   $index_file = $clone_root . "/" . $aff_num . "/index.html";
   $new_index = $index_file . ".old";

   $index_file2 = $clone_root . "/" . $aff_num . "/index.htm";
   $new_index2 = $index_file2 . ".old";
   
   $index_file3 = $clone_root . "/" . $aff_num . "/index.shtml";
   $new_index3 = $index_file3 . ".old";


   $aff_dir = $clone_root . "/" . $aff_num;
   &start_url;
   if (-e $disable_file)
   {
      print "<B>That account was already disabled...no further action is required.</B></BODY></HTML>\n"; 
   }
   elsif (-e $aff_dir)
   {
      open (DISFILE, ">$disable_file");
      close(DISFILE);
      if (-e $index_file) { system "chmod 777 $index_file"; system "cp $index_file $new_index"; system "rm $index_file";}      
      if (-e $index_file2) { system "chmod 777 $index_file2"; system "cp $index_file2 $new_index2"; system "rm $index_file2";}
      if (-e $index_file3) { system "chmod 777 $index_file3"; system "cp $index_file3 $new_index3"; system "rm $index_file3";}

      if (-e $new_index)  { open (NEWFILE, ">$index_file"); }
      if (-e $new_index2) { open (NEW2, ">$index_file2"); }
      if (-e $new_index3)  { open (NEW3, ">$index_file3"); }
      
      open (TEMPFILE, "<$disable_html");
      while(<TEMPFILE>) 
      { 
	if (-e $new_index) { print NEWFILE; }
	if (-e $new_index2) { print NEW2; }
	if (-e $new_index3) { print NEW3; }
      } #index.html now has "disabled" message
      close(TEMPFILE);
      close(NEWFILE);    
      close(NEW2);
      close(NEW3);
      print "<B>Affiliate account $aff_num has been disabled.</B></BODY></HTML>";
   }
   else
   {
      print "<B>That affiliate account does not exist.</B></BODY></HTML>\n";
   }
   exit;
}
