#!/usr/bin/perl
################################################################################
#
# This Perl program code COPYRIGHT 2005 Paul Galloway. All Rights Reserved.
# Program may not be sold or distributed except by express written permission
# of the author.
#
# The use of any part of this program or any code segments from it for any
# purpose, personal or commercial, is forbidden except by express written 
# permission of Paul Galloway.
#
# You may contact the author at the following email address:
#
# Email: paulg@paulgalloway.com
#
##############################################################################

unshift (@INC, ".");
require (options);
open(STDERR, ">errors/update.errors");
system "chmod 777 $originals_dir";
system "chmod 777 $clone_root";
system "chmod 777 $log_dir";
system "chmod 777 $temp_dir";
system "chmod 777 $ip_dir";

&get_input;

$aff_num = $FORM{'dealernum'};
$aff_num =~ s/ //g;
$password = $FORM{'password'};
$password =~ s/ //g;
$cgi_script = $cgi_url . "/update.cgi";

&check_password;

if ($aff_num eq "") {&default;}
if ($aff_num ne "ALL")
{
	$fullpath = $nfo_dir . "/" . $aff_num . ".nfo";
	if (-e $fullpath)
	{ 
		&start_url;
		opendir(FILELIST, "$originals_dir");   
		@allfiles = readdir(FILELIST);
		closedir(FILELIST);
		@files = (); #in case we ever run this as Apache Registry code.
		foreach $possible (@allfiles)
		{
			if ($possible =~ /\.htm/ || $possible =~ /\.shtm/) 
			{ 
				$fullpathname = $originals_dir . "/" . $possible;
				push(@files, $fullpathname); 
			}
		}
		&update;
		print "</BODY></HTML>";
	}
	else
	{
		&start_url;
		print "A match couldn't be found for that affiliate number. <P>Please click on the \"BACK\" button and be sure you have entered the information correctly, then click on, \"GO\" again.";
		print "</BODY></HTML>";
	}
} 
else
{
	&get_dealers;
	$num_of_dealers = @dealers;
	if ($num_of_dealers > 0)
	{ 
		&start_url;
		opendir(FILELIST, "$originals_dir");   
		@allfiles = readdir(FILELIST);
		closedir(FILELIST);

		@files = (); #in case we ever run this as Apache Registry code.
		foreach $possible (@allfiles)
		{
			if ($possible =~ /\.htm/ || $possible =~ /\.shtm/) 
			{
				$fullpathname = $originals_dir . "/" . $possible;
				push(@files, $fullpathname); 
			}
    		}
    
    
		foreach $aff_num (@dealers)
		{
			&update;
		}
		print "</BODY></HTML>";
	}
	else
	{
		&start_url;
		print "No affiliate sites could be found in $clone_root . . .";
		print "</BODY></HTML>";
	}
}

exit;


sub get_input
{
	if ($ENV{'REQUEST_METHOD'} eq "GET")
	{
		$buffer=$ENV{'QUERY_STRING'};
	}
	else 
	{
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	}

	@pairs = split(/&/, $buffer);
	foreach $pair (@pairs) 
	{
		($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/<!--(.|\n)*-->//g;
		$value =~ s/\|/ /g;
		$FORM{$name} = $value;
	}
	foreach $key (keys %FORM)
	{
		$FORM{$key} =~ tr/\&\;\`\'\\\"\|\*\?\~\<\>\^\(\)\[\]\{\}\$\n\r/                      /;
	}
	if ($FORM{'level'} eq "") {$FORM{'level'} = 1;}
	$ip_address = $ENV{'REMOTE_HOST'};
}


sub update 
{  
	&get_dealer_info;
	$clone_dir = $clone_root . "/" . $aff_num; 
	if ($aff_num eq "" || $aff_num =~ /^\./) { return; }
	
	#ONLY DO THIS IF STATIC AFF PAGES ARE SUPPORTED AS EVIDENCED BY EXISTING AFF_NUM DIRECTORY
	########
	unless (-e $clone_dir && $clone_root ne "") { return; }
	########

	system "chmod 777 $clone_dir/*.htm";
	system "chmod 777 $clone_dir/*.html";
	system "chmod 777 $clone_dir/*.shtml";
	system "rm $clone_dir/*.htm";
	system "rm $clone_dir/*.html"; 
	system "rm $clone_dir/*.shtml"; 
	#print "Updating $clone_dir...<BR>";
	foreach $file(@files)
	{ 
		chop $file if ($file =~ /\n$/);
		@pathfields= split(/\//, $file);
		$filename = pop(@pathfields);
		open(TEMPLATE, "<$file");
		@lines=<TEMPLATE>;
		close(TEMPLATE);
		$newfile = $clone_dir . "/" . $filename;
		system "chmod 777 $newfile";
		print "Updating $newfile . . .<BR>";
		open(NEWFILE, ">$newfile");
		$line = join('', @lines);
		$line =~ s/AFF_NUM/$aff_num/g;
		$line =~ s/AFF_NAME/$dealer_name $dealer_lastname/g;
		$line =~ s/AFF_FIRSTNAME/$dealer_name/g;
		$line =~ s/AFF_LASTNAME/$dealer_lastname/g;
		$line =~ s/AFF_EMAIL/$dealer_email/g;
		$line =~ s/AFF_URL/$dealer_url/g;
		$line =~ s/AFF_PHONE/$phone/g;
		$line =~ s/AFF_ADDRESS/$address1/g;
		$line =~ s/AFF_SUITE/$suite/g;
		$line =~ s/AFF_CITY/$city/g;
		$line =~ s/AFF_STATE/$state/g;
		$line =~ s/AFF_ZIP/$zip/g;
		$line =~ s/AFF_COUNTRY/$country/g;
		$line =~ s/AFF_CUSTOM1/$c1/g;
		$line =~ s/AFF_CUSTOM2/$c2/g;
		$line =~ s/AFF_CUSTOM3/$c3/g;
		$line =~ s/AFF_CUSTOM4/$c4/g;
		$line =~ s/AFF_CUSTOM5/$c5/g;
		print NEWFILE "$line";
		close(NEWFILE);
	}
	system "chmod $security $clone_dir/*";
	system "chmod 755 $clone_dir/*.html";
	system "chmod 755 $clone_dir/*.htm";
	system "chmod 755 $clone_dir/*.shtml";

	#print "Update complete for affiliate number $aff_num<P>";
}


sub get_dealers
{
	opendir(DEALERDIR, "$nfo_dir");
	@dealer_info_files = grep(/\.nfo/, readdir(DEALERDIR));
	closedir(DEALERDIR);
	foreach $dealer_info_file (@dealer_info_files)
	{
		my $dnum = $dealer_info_file;
		$dnum =~ s/\.nfo//;
		push (@dealers, $dnum);
	}
}


sub get_dealer_info
{
  $info_file = $nfo_dir . "/" . $aff_num . ".nfo";
  system "chmod 777 $info_file";
  open(DEALERFILE, "<$info_file");
  @lines=<DEALERFILE>;
  close(DEALERFILE);
  system "chmod $security $info_file";
  $dataline=$lines[2];
  if ($dataline =~ /\n$/ ) {chop $dataline;}
  ($dealer_name,$dealer_lastname,$dealer_email,$address1,$suite,$city,$state,$zip,$phone,$country,$dn,$pw,$ld,$ip,$cb1,$cb2,$c1,$c2,$c3,$c4,$c5,$dealer_url,$dealer_ul) = split (/\|/, $dataline);
  $dealer_level = $lines[1];
  if ($dealer_level =~ /\n$/ ) {chop $dealer_level;}
}


sub default
{
  &start_url;
  print "<CENTER><H2>Update Affiliate Site(s)</H2></CENTER><HR>";
  print "<FORM ACTION=\"$cgi_script\" METHOD=\"POST\"><input type=\"hidden\" name=\"password\" value=\"$password\">";
  print "Affiliate number whose site you want to update):<BR>";
  print "<INPUT TYPE=\"text\" NAME=\"dealernum\" SIZE=20 VALUE=\"ALL\">";
  print "<FONT SIZE=2 COLOR=\"0000FF\"> (\"ALL\" = all affiliate sites)</FONT><P>";
  print "<INPUT TYPE=\"hidden\" NAME=\"required\" VALUE=\"dealernum,password\">";
  print "<CENTER><INPUT TYPE=\"submit\" VALUE=\"    CREATE UPDATED SITE(S)    \"><HR>";
  print "</BODY>\n";
  print "</HTML>\n";
  exit;
}


sub check_password
{
  $passfile = $log_dir . "/" . "password.txt"; 
  if (-e $passfile)
  {
    system "chmod 444 $passfile";
    open(PASSFILE, "<$passfile");
    $master_password = <PASSFILE>;
    close(PASSFILE);
    system "chmod $security $passfile";
    chop $master_password if ($master_password =~ /\n$/);
    $try = crypt ($password, "aa");
    if ($master_password eq $try)
    {
      return;
    }
  }
  &start_url;
  print "Sorry, \"$password\" does not match the recorded master password (admin password) -- please try again.";
  print "</BODY></HTML>";
  exit;
}

