#!/usr/bin/perl
################################################################################
#
# This Perl program code COPYRIGHT 2005 Paul Galloway. All Rights Reserved.
# Program may not be sold or distributed except by express written permission
# of the author.
#
# The use of any part of this program or any code segments from it for any
# purpose, personal or commercial, is forbidden except by express written 
# permission of Paul Galloway.
#
# You may contact the author at the following email address:
#
# Email: paulg@paulgalloway.com
#
##############################################################################
# z.cgi?pagename&affnum!extendedcode
# or z.cgi?affnum!extendedcode
#
# pagename, affnum, extendedcode must NOT include an ampersand ("&") character!
#(pagename& and !extendedcode is are optional arguments)
#

unshift (@INC, ".");
require (options);
open(STDERR, ">errors/z.errors");
system "chmod 777 $originals_dir";
system "chmod 777 $clone_root";
system "chmod 777 $log_dir";
system "chmod 777 $temp_dir";
system "chmod 777 $ip_dir";
if (-e "ycookies.pm") { require (ycookies);}

$buffer=$ENV{'QUERY_STRING'};
$buffer =~ tr/\;\`\'\\\"\|\*\?\~\<\>\^\(\)\[\]\{\}\$\n\r/                     /;

if ($buffer =~ /\&/) 
{ 
	($pagename, $dn) = split(/&/, $buffer,2);
}
else
{
	$dn = $buffer;
}

if ($odd_day_dir ne "") #ycookies has been loaded
{
	 $dn = &determine_affnum($dn); 
}
($aff_num, $extended) = split(/\!/, $dn);
if (-e "ycookies.pm") { ($aff_num, $sub_num) = &determine_affnum($aff_num); }
if ($aff_num ne "" && $log_hits > 0) { &update_logs; }
&return_data;
exit;


sub update_logs
{
	my $log_line;
	
	&get_date;
  	#returns $long_date = "$year-$months[$mon]-$mday\@$hour\:$min\:$sec";
  	#returns $month = [1-12]
  	my @date_stuff = split (/\-/,$long_date);
  	my $this_year = $date_stuff[0];
  	my ($this_day, $this_time) = split(/\@/, $date_stuff[2]);
  	my $month = $date_stuff[1];
  	if (length($this_day) < 2) { $this_day = '0' . $this_day;} #want two characters always
  	#if (length($month) < 2) { $month = '0' . $this_day; }  #want two characters always
    	
	my $traffic_log_dir = $access_log_dir;
  	if ($traffic_log_dir eq "")
  	{
  		$traffic_log_dir = $log_dir . "/access_logs";
  	}
  	
  	if (! -e $$traffic_log_dir)
	{
  		mkdir ($traffic_log_dir, 0777);
  	}

  	$d_log_file = $traffic_log_dir . "/" . $this_year . '-' . $month . '-' . $this_day . '.traffic'; 	
    	
    	$host = $ENV{'REMOTE_HOST'};
    	$host = "- n/a -" if ($host eq "");
    	
    	$ip = $ENV{'REMOTE_ADDR'} if ($ip eq "");
      	$ip = "- n/a -" if ($ip eq "");
      	
      	@fileurl = split(/\//, $ENV{'HTTP_REFERER'}); 
      	$file = pop(@fileurl);
      	$file =~ s/\..*//;
      	$referrer = "N/A"; # the REFERER environment variable will contain the name of the page containing the image -- not the referring page.
      	
      	$pagename ||= $file;

 	$log_line = "$aff_num\|$extended\|$month\/$this_day\/$this_year $this_time\|$ip\|$host\|$pagename\|$referrer\n";
      	
      	chmod (0666, $d_log_file);
    	open (LOGFILE, ">>$d_log_file");
    	print LOGFILE $log_line;
    	close(LOGFILE);
}


sub return_data
{
	print "Content-type: image/gif\n\n";
	$img_string = "47 49 46 38 39 61 01 00 01 00 80 00 00 00 00 00 FF FF FF 21 F9 04 01 00 00 01 00 2C 00 00 00 00 01 00 01 00 00 02 01 4C 00 3B";
	@bytes = split(/\s/, $img_string);
	foreach $byte (@bytes)
	{
		$byte =~ s/([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		print "$byte";
	}
        #open(IMAGEFILE, "<$image_file");
        #while(<IMAGEFILE>)
        #{
        #    print;
        #}
        #close(IMAGEFILE);
}


sub get_date
{
	#creates a whole slew of global date variables:
	# examples: 
	# date = "09:23:12 01/12/1999"
	# long_date = "1999-Jan-12@09:23:12"
	# thismonth = "Jan"
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
    	$sec = "0$sec" if ($sec < 10);
    	$min = "0$min" if ($min < 10);
	$hour = "0$hour" if ($hour < 10);
	$mday = "0$mday" if ($mday < 10);
	$month=$mon+1;
	$month = "0$month" if ($month < 10);
	my @months = ("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
	$year += 1900;
  	$yyyymmdd = "$year$month$mday";
	$date = "$hour\:$min\:$sec $month/$mday/$year";
  	chop($date) if ($date =~ /\n$/);
  	$long_date = "$year-$months[$mon]-$mday\@$hour\:$min\:$sec";
  	$thismonth = $months[$mon];
}
